package jp.co.glossom.adfurikun

import jp.tjkapp.adfurikunsdk.moviereward.AdfurikunSdk

/**
 * アドフリくん共通
 */
internal object AdfurikunCommons {

    init {
        AdfurikunSdk.init(AdfurikunPlugin.currentActivity)
    }

    /**
     * 広告音を設定
     * @param arguments
     */
    fun setSoundState(arguments: HashMap<String, *>?) {
        (arguments?.get(Constants.KEY_BOOL) as? Boolean)?.let {
            AdfurikunSdk.setAdfurikunMovieSoundState(it)
        }
    }

    /**
     * テストモードを設定
     * @param arguments
     */
    fun setTestMode(arguments: HashMap<String, *>?) {
        (arguments?.get(Constants.KEY_BOOL) as? Boolean)?.let {
            AdfurikunSdk.isAdNetworkTestMode = it
        }
    }

    /**
     * ユーザーGDPR同意を設定
     * @param arguments
     */
    fun setUserConsent(arguments: HashMap<String, *>?) {
        (arguments?.get(Constants.KEY_BOOL) as? Boolean)?.let {
            AdfurikunSdk.hasUserConsent = it
        }
    }

    /**
     * プラグインバージョンを設定
     * @param arguments
     */
    fun setPluginVersion(arguments: HashMap<String, *>?) {
        val pluginVersion = (arguments?.get(Constants.KEY_PLUGIN_VERSION) as? String) ?: ""
        if (pluginVersion.isNotBlank()) {
            AdfurikunSdk.setPlatformInfo("flutter", pluginVersion)
        }
    }

    /**
     * Argument情報
     *
     * @param number
     * @param appId
     * @param adNetworkKey
     * @param title
     * @param description
     * @param errorCode
     */
    fun getArgs(number: Int, appId: String, adNetworkKey: String? = null, title: String? = null, description: String? = null, errorCode: Int? = null): HashMap<String, Any> {
        val args = hashMapOf<String, Any>()
        args[Constants.KEY_NUMBER] = number
        args[Constants.KEY_ID] = appId
        if (adNetworkKey != null) {
            args[Constants.KEY_AD_NETWORK_KEY] = adNetworkKey
        }
        if (title != null) {
            args[Constants.KEY_TITLE] = title
        }
        if (description != null) {
            args[Constants.KEY_DESCRIPTION] = description
        }
        if (errorCode != null) {
            args[Constants.KEY_ERROR_CODE] = errorCode
        }
        return args
    }
}